#include <fcntl.h>
#include "SDL/SDL.h"
#include "sprite.h"
#include <stdlib.h>
#include <stddef.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

	TTF_Font	*font ;
//SDL_Surface *up = TTF_RenderText_Solid ("ariel", "Up was pressed.", textColor);
//	static	sprite	s;
	long	s_max;					// Number of last Sprite object, doesn't mean that there really is that many objects
	SDL_Surface		*screen;		/*	Will keep it here for a while	*/
	

struct sprite_struct
{
	
	char* title;
	char a;
 	unsigned long 	instances;
	unsigned long	visible, top_frame;
	SDL_Surface 	**frame;
	SDL_Rect	  offset;
	Mix_Chunk	**sound;
   // unsigned long 		x,y
	long			hor,ver;
	unsigned long 	current_frame;	/* where in the animation you are */
	unsigned long	c_anim;	/* the active animation */
	unsigned long	*a_length;
	unsigned long	**a_list;
	
	/* removed because efficiency */
//		char			**name;	/* name of the animation, this could for instance be "jump", or "crouch", or "stand_still" */
	
}  ;
  
// Creates s[x]
void sprite_new(unsigned long sprite_no);

void sprite_a_load(sprite s, unsigned long anim_number, unsigned long length, const unsigned long anim[] )
{
	/* names the animation for the Serie by sending the address to the pointer variable */
//	s[serie] -> animation[0]->name[0] = (char*) anim_name;

//    s -> a_length = malloc(30);
//	if (!s->a_length)
//		s->a_lengthmalloc

//  s->a_length=  realloc (s-> a_length ,30);
	
 	s->a_length=realloc (s->a_length, (anim_number+1)*sizeof(length) );
	s -> a_length[0] = length+1;

//	s -> a_list = malloc(30);
	s->a_list = realloc (s->a_list, (1+anim_number) * sizeof(s->a_list) );

	s -> a_list[anim_number] = (unsigned long*) anim;
}

/* sets the active animation */
void A(sprite s,  unsigned long anim_numb ) 	
{

	s->c_anim = anim_numb;
	s->current_frame = 0; /* start at 0 of animation list */

}


//void sprite_name(sprite s, const char name[])
//{
//	s->title = (char*) name;
//}



/*	Sets the X coordinate for a chosen Object	*/
void	X(sprite s, long position)
{
	s->offset.x = position;
}

/*	Guess	*/
void	Y(sprite s, long position)
{
	s->offset.y = position;
}

void	H(sprite s, long speed)
{
	s->hor = speed;
}

void	V(sprite s, long speed)
{
	s->ver = speed;
}



/*	This selects the current frame in a Sprite object to be shown	*/
void	N(sprite s, unsigned long show)
{
	s->visible = show;
}

void	show_sprite_info(sprite item)
{
//	printf ("Showing sprite Info %d", item->y);
}

char *GetBufferFromResource(char *resourcefilename, const char *resourcename, int *filesize);

void sprite_load_image(sprite s, unsigned long frame_no, const char *name) 
{
//	sprite_create(sprite_no);
    s->visible=1;
	
	/* If the pointervector for frame isn't allocated yet do so */
//	if (!s->frame) {
//	   	s->frame = malloc( (frame_no+1)*sizeof (s->frame) ) ;
//   }
		//	   	perror("PUT");
	
	  	/* error checking */
//  	  	if (s->frame)
//			printf ("Frame Pointer initialized \n");
//   		else
//	   		perror ("Error while initializing Pointer Frame");

//    	s->top_frame=frame_no;
//	}
//	else {
		
	
	if( s->top_frame<=frame_no) {
		s->frame = realloc (s->frame, (frame_no+1)*sizeof (s->frame) );
		s->top_frame=frame_no;
	
	if (s)
		perror("memory allocated");
	}

//	}
	

//	else {
//		if (frame_no > s->top_frame++)  
//          	s->frame = realloc (s->frame, sprite_no+1*sizeof(s->frame) );
//	}
//    s->frame[0] = malloc(40);
	//Get the bitmap's buffer and size from the resource file
	int filesize = 0;
	char *buffer = GetBufferFromResource("resource.dat", name, &filesize);

	perror("here and there");	
	//Load the buffer into a surface using RWops
	SDL_RWops *rw = SDL_RWFromMem(buffer, filesize);
	SDL_Surface *temp = SDL_LoadBMP_RW(rw, 1);
	
	//Release the bitmap buffer memory
	free(buffer);
	
	//Were we able to load the bitmap?
	if (temp == NULL) 
	{
		printf("Unable to load bitmap: %s\n", SDL_GetError());
		exit(1);
	}
	
	//Convert the image to optimal display format
	SDL_Surface *image;
	s->frame[frame_no] = SDL_DisplayFormat(temp);
	
	//Free the temporary surface
	SDL_FreeSurface(temp);
	
	//Return our loaded image
//    return image;
}
 
/* Creates s[x] */

sprite sprite_create_inst(unsigned long n)
{
	sprite s;
	s = malloc ( (n+1) * sizeof (struct sprite_struct));
    s->instances = n;
	
	/*	Error checking	*/
	if (s)	{
		printf("Memory allocation suceeded\n");	
  	 }	
	else {
		printf("Memory allocation failed\n");
		return 0;
  	 }

     return s; 
		
}	


sprite *sprite_create(unsigned long element)			// Uses Static *s implicitly.
{
        
	/*	This section occurs if assignment to memory = NULL, (not allocated earlier) */
	
	sprite *s = malloc ( (element+1)*sizeof (sprite) );
	unsigned long i;
	for (i = 0; i<= element; i++)
		s[i] = malloc (sizeof(struct sprite_struct) );
	
		
// 	s[0]= malloc (sizeof (struct sprite_struct) );   

//	s = malloc (sizeof(struct sprite_struct) );		
 

		/*	Error checking	*/
		if (s)	{
	   		printf("Memory allocation suceeded\n");	
   		 }	
		else {
			printf("Memory allocation failed\n");
			return 0;
   		 }

  //  s->frame=0; 
		s[0]->instances=element;
		s[1]->instances=element;
		s[2]->instances=element;
		return s;							
 }
  
	


unsigned long get_anim(sprite sprit);

void	show(sprite s)
{
	int 	i;
	SDL_Surface	*message;
	SDL_Color 	hej = {133,233,233};
//	if (TTF_Init () == -1 )
//	{
//		return ;
//	}
//  font = TTF_OpenFont("lazy.ttf",72);
//	message = TTF_RenderText_Solid(font, "hej",hej); 
	
	
	//	font = TTF_OpenFont("lazy.ttf",72);
	
	
	SDL_Rect	offset;
   

	SDL_Rect	*clip = NULL;
	
//	offset.x= 120;
//	offset.y = 300;
	
	SDL_Rect skarm;
	skarm.x=0;
	skarm.y=0;
	skarm.w = 640;
	skarm.h = 480;
	SDL_FillRect(screen, &skarm,0);
	
	
	for (i=0; i < s->instances; i++) {
  //  i=0;  
	if (s[i].visible == 1)
		{
			unsigned long display_frame;
			display_frame=s[i].a_list[(int) s[i].c_anim] [(int) s[i].current_frame++]; 
			if (s[i].current_frame>= s[i].a_length[ s[i].c_anim] )
				s[i].current_frame=0;

			offset.x = s[i].offset.x+=s[i].hor;
			offset.y = s[i].offset.y+=s[i].ver;
			
			offset.w = s[i].offset.w;
			offset.h = s[i].offset.h;

			
			SDL_BlitSurface ( s[i].frame [display_frame  ] ,0, screen, &offset);
	
	 //   	SDL_BlitSurface ( s[i].frame [ display_frame ] ,0, screen, &offset);
		}
    }
		SDL_Flip(screen);
}


char *GetBufferFromResource(char *resourcefilename, const char *resourcename, int *filesize) 
{
	//Try to open the resource file in question
	int fd = open(resourcefilename, O_RDONLY);
	if (fd < 0) 
	{
		perror("Error opening resource file");
		exit(1);
	}
	
	//Make sure we're at the beginning of the file
	lseek(fd, 0, SEEK_SET);
	
	//Read the first INT, which will tell us how many files are in this resource
	int numfiles;
	read(fd, &numfiles, sizeof(int));
	
	//Get the pointers to the stored files
	int *filestart =  malloc(numfiles *sizeof(int*)  );
	read(fd, filestart, sizeof(int) * numfiles);
	
	//Loop through the files, looking for the file in question
	int filenamesize;
	char *buffer;
	int i;
	for(i=0;i<numfiles;i++) 
	{
		char *filename;
		//Seek to the location
		lseek(fd, filestart[i], SEEK_SET);
		//Get the filesize value
		read(fd, filesize, sizeof(int));
		//Get the size of the filename string
		read(fd, &filenamesize, sizeof(int));
		//Size the buffer and read the filename
		filename = (char *) malloc(filenamesize + 1);
		read(fd, filename, filenamesize);
		//Remember to terminate the string properly!
		filename[filenamesize] = '\0';
		//Compare to the string we're looking for
		if (strcmp(filename, resourcename) == 0) 
		{
			//Get the contents of the file
			buffer = (char *) malloc(*filesize);
			read(fd, buffer, *filesize);
			free(filename);
			break;
		}
		//Free the filename buffer
		free(filename);
	}
	
	perror("fasdfsd");
	//Release memory
	free(filestart);

	perror("got here");
	
	//Close the resource file!
	close(fd);
	
	//Did we find the file within the resource that we were looking for?
	if (buffer == NULL) 
	{
		printf("Unable to find '%s' in the resource file!\n", resourcename);
		exit(1);
	}
	
	//Return the buffer
	return buffer;
}

